﻿namespace Netina.Domain.MartenEntities.Pages;

public class BasePage : MartenEntity
{
    public string Title { get; set; } = string.Empty;
    public string Description { get; set; } = string.Empty;
    public string Content { get; set; } = string.Empty;
    public bool IsCustomPage { get; set; }
    public bool IsHtmlBasePage { get; set; }
    public string Slug { get; set; } = string.Empty;
    public string Type { get; set; } = string.Empty;
    public string Data { get; set; } = string.Empty;
    public bool Indexing { get; set; } = true;
    public List<BasePageSection> Sections { get; set; } = new();
}

public class BasePageSection
{
    public string Title { get; set; } = string.Empty;
    public string Description { get; set; } = string.Empty;
    public string CTAText { get; set; } = string.Empty;
    public string CTARoute { get; set; } = string.Empty;
    public BasePageSectionType Type { get; set; }
    public string Query { get; set; } = string.Empty;
}

public enum BasePageSectionType
{
    [Display(Name = "اسلایدر محصولات")]
    ProductSlider = 0,
    [Display(Name = "اسلایدر دسته بندی محصولات")]
    ProductCategorySlider = 1,
    [Display(Name = "اسلایدر بلاگ ها")]
    BlogSlider = 2
}